# file: batch_norm_layer_dense_batch.py
#===============================================================================
# Copyright 2014-2017 Intel Corporation
# All Rights Reserved.
#
# If this  software was obtained  under the  Intel Simplified  Software License,
# the following terms apply:
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#
#
# If this  software  was obtained  under the  Apache License,  Version  2.0 (the
# "License"), the following terms apply:
#
# You may  not use this  file except  in compliance  with  the License.  You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
#
#
# Unless  required  by   applicable  law  or  agreed  to  in  writing,  software
# distributed under the License  is distributed  on an  "AS IS"  BASIS,  WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
# See the   License  for the   specific  language   governing   permissions  and
# limitations under the License.
#===============================================================================

#
# !  Content:
# !    Python example of forward and backward batch normalization layer usage
# !
# !*****************************************************************************

#
## <a name="DAAL-EXAMPLE-PY-BATCH_NORMALIZATION_LAYER_BATCH"></a>
## \example batch_norm_layer_dense_batch.py
#

import os
import sys

from daal.algorithms.neural_networks import layers
from daal.data_management import HomogenTensor, TensorIface

utils_folder = os.path.realpath(os.path.abspath(os.path.dirname(os.path.dirname(__file__))))
if utils_folder not in sys.path:
    sys.path.insert(0, utils_folder)
from utils import printTensor, readTensorFromCSV

# Input data set name
datasetFileName = os.path.join("..", "data", "batch", "layer.csv")
dimension = 1

if __name__ == "__main__":

    # Read datasetFileName from a file and create a tensor to store input data
    data = readTensorFromCSV(datasetFileName)

    printTensor(data, "Forward batch normalization layer input (first 5 rows):", 5)

    # Get collection of dimension sizes of the input data tensor
    dataDims = data.getDimensions()
    dimensionSize = dataDims[dimension]

    # Create a collection of dimension sizes of input weights, biases, population mean and variance tensors
    dimensionSizes = [dimensionSize]

    # Create input weights, biases, population mean and population variance tensors
    weights = HomogenTensor(dimensionSizes, TensorIface.doAllocate, 1.0)
    biases = HomogenTensor(dimensionSizes, TensorIface.doAllocate, 2.0)
    populationMean = HomogenTensor(dimensionSizes, TensorIface.doAllocate, 0.0)
    populationVariance = HomogenTensor(dimensionSizes, TensorIface.doAllocate, 0.0)

    # Create an algorithm to compute forward batch normalization layer results using default method
    forwardLayer = layers.batch_normalization.forward.Batch()
    forwardLayer.parameter.dimension = dimension
    forwardLayer.input.setInput(layers.forward.data, data)
    forwardLayer.input.setInput(layers.forward.weights, weights)
    forwardLayer.input.setInput(layers.forward.biases, biases)
    forwardLayer.input.setInputLayerData(layers.batch_normalization.forward.populationMean, populationMean)
    forwardLayer.input.setInputLayerData(layers.batch_normalization.forward.populationVariance, populationVariance)

    # Compute forward batch normalization layer results
    forwardResult = forwardLayer.compute()

    printTensor(forwardResult.getResult(layers.forward.value), "Forward batch normalization layer result (first 5 rows):", 5)
    printTensor(forwardResult.getLayerData(layers.batch_normalization.auxMean), "Mini-batch mean (first 5 values):", 5)
    printTensor(forwardResult.getLayerData(layers.batch_normalization.auxStandardDeviation), "Mini-batch standard deviation (first 5 values):", 5)
    printTensor(forwardResult.getLayerData(layers.batch_normalization.auxPopulationMean), "Population mean (first 5 values):", 5)
    printTensor(forwardResult.getLayerData(layers.batch_normalization.auxPopulationVariance), "Population variance (first 5 values):", 5)

    # Create input gradient tensor for backward batch normalization layer
    inputGradientTensor = HomogenTensor(dataDims, TensorIface.doAllocate, 10.0)

    # Create an algorithm to compute backward batch normalization layer results using default method
    backwardLayer = layers.batch_normalization.backward.Batch()
    backwardLayer.parameter.dimension = dimension
    backwardLayer.input.setInput(layers.backward.inputGradient, inputGradientTensor)
    backwardLayer.input.setInputLayerData(layers.backward.inputFromForward, forwardResult.getResultLayerData(layers.forward.resultForBackward))

    # Compute backward batch normalization layer results
    backwardResult = backwardLayer.compute()

    printTensor(backwardResult.getResult(layers.backward.gradient), "Backward batch normalization layer result (first 5 rows):", 5)
    printTensor(backwardResult.getResult(layers.backward.weightDerivatives), "Weight derivatives (first 5 values):", 5)
    printTensor(backwardResult.getResult(layers.backward.biasDerivatives), "Bias derivatives (first 5 values):", 5)
